<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
import qs from 'qs';
import { MockAdapter } from '@/mock/mock-adapter';
const mock = MockAdapter.getInstance();
<#--  日志方法: BEGIN  -->
<#macro startLog appMethod>
    console.groupCollapsed("实体:${item.codeName?lower_case} 方法: ${appMethod.getCodeName()}");
    console.table({url:config.url, method: config.method, data:config.data});
</#macro>
<#macro endLog appMethod dataName>
    console.groupCollapsed("response数据  status: "+status+" data: ");
    console.table(${dataName});
    console.groupEnd();
    console.groupEnd();
</#macro>
<#--  日志方法: END  -->

// 模拟数据
const mockDatas: Array<any> = [
<#if de.getAllPSDESampleDatas?? &&  de.getAllPSDESampleDatas()??>
<#list de.getAllPSDESampleDatas() as data>
    ${data.getDataJO().toString()}<#if data_has_next>,</#if>
</#list>
</#if>
];
<#--  工作流相关  -->
<#if de.getAllPSDEWFs()??>
<#--  //工作流相关
/**
 * 工作流启动
 *
 * @param {string} srfkey
 * @param {*} version
 */
function start(srfkey: string, version: any) {
    let wfversion: any = getWFVersion(version);
    const _item2 = mockDatas.find((item: any) => Object.is(item.srfkey, srfkey));
    let node = wfversion.nodes.find((item: any) => Object.is(item.from, wfversion.startnode));
    _item2.wfstep = node.wfstepvalue;
    _item2.applywfstate = 1;
}

/**
 * 改变工作流步骤
 *
 * @param {string} srfkey
 * @param {*} version
 * @param {string} action
 */
function changeStep(srfkey: string, version: any, action: string) {
    let wfversion: any = getWFVersion(version);
    const _item2 = mockDatas.find((item: any) => Object.is(item.srfkey, srfkey));
    let link = wfversion.links.find((item: any) => Object.is(item.name, action));
    let node = wfversion.nodes.find((item: any) => Object.is(item.id, link.to));
    _item2.wfstep = node.wfstepvalue;
}

/**
 * 工作流完成
 *
 * @param {string} srfkey
 */
function finish(srfkey: string) {
    const _item2 = mockDatas.find((item: any) => Object.is(item.srfkey, srfkey));
    _item2.wfstep = "";
    _item2.applywfstate = 2;
}

/**
 * 获取工作流版本
 *
 * @param {*} version
 * @returns
 */
function getWFVersion(version: any) {
    if (version == 1)
        return '';
}

<#list de.getAllPSDEWFs() as dewf>
<#assign workflow=dewf.getPSWorkflow() >
<#if workflow.getPSWFVersions()??>
<#list workflow.getPSWFVersions() as wfversion>
<#if wfversion.getPSWFProcesses()??>
<#list wfversion.getPSWFProcesses() as process>
    <#if (process.getWFProcessType()=='INTERACTIVE') >
mock.onPost(new RegExp(/wf\/${workflow.getCodeName()?lower_case}\/v${wfversion.getWFVersion()}\/${process.getWFStepValue()?lower_case}/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    let _items: Array<any> = [];
    for (var index in mockDatas) {
        if(items[index].wfstep=='${process.getWFStepValue()}'){
            _items.push(items[index]);
        }
        
    }
    const total = _items.length;
    return [status, {
        records: _items,
        total: total,
    }];
});

    <#if process.getPSWFLinks()??>
    <#list process.getPSWFLinks() as link>
mock.onPost(new RegExp(/wf\/${workflow.getCodeName()?lower_case}\/v${wfversion.getWFVersion()}\/${link.getName()?lower_case}\/[^\/]/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    const { url }: { url: string } = config;
    const _arr: Array<string> = url.split('/');
    const _str = _arr[_arr.length - 1];
    if (!_str || Object.is(_str, '')) {
        return [500, null];
    }
    const [srfkey,] = _str.split(';');
    let data = JSON.parse(config.data) 
    const _item2 = items.find((item: any) => Object.is(item.srfkey, srfkey));
    <#if (link.getToPSWFProcess().getWFProcessType()=='INTERACTIVE') >
    _item2.${dewf.getWFStepPSDEField().getCodeName()?lower_case}='${link.getToPSWFProcess().getWFStepValue()}';
    <#elseif (link.getToPSWFProcess().getWFProcessType()=='END')>
    _item2.${dewf.getWFStepPSDEField().getCodeName()?lower_case}='';
    _item2.${dewf.getUDStatePSDEField().getCodeName()?lower_case}='';
    </#if>
    return [status, {}];
});

    </#list>
    </#if>
    <#elseif (process.getWFProcessType()=='START')>
mock.onPost(new RegExp(/wf\/${workflow.getCodeName()?lower_case}\/v${wfversion.getWFVersion()}\/saveandstart\/[^\/]/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    const { url }: { url: string } = config;
    const _arr: Array<string> = url.split('/');
    const _str = _arr[_arr.length - 1];
    if (!_str || Object.is(_str, '')) {
        return [500, null];
    }
    const [srfkey,] = _str.split(';');
    let data = JSON.parse(config.data)
    const _item2 = items.find((item: any) => Object.is(item.srfkey, srfkey));
    <#if process.getPSWFLinks()??>
    <#list process.getPSWFLinks() as link>
    <#if (link.getToPSWFProcess().getWFProcessType()=='INTERACTIVE') >
    _item2.${dewf.getWFStepPSDEField().getCodeName()?lower_case}='${link.getToPSWFProcess().getWFStepValue()}';
    </#if>
    _item2.${dewf.getUDStatePSDEField().getCodeName()?lower_case}='${workflow.getEntityWFState()}';
    </#list>
    </#if>
    return [status, {}];
});    
    </#if>
</#list>
</#if>
</#list>
</#if>
</#list>  -->
</#if>

<#-- 实体接口mock数据start -->
<#if item.getAllPSAppDEMethods?? && item.getAllPSAppDEMethods()??>
<#list item.getAllPSAppDEMethods() as singleAppMethod>
<#if singleAppMethod.getPSDEServiceAPIMethod?? &&  singleAppMethod.getPSDEServiceAPIMethod()??>
 <#assign singleServiceApi = singleAppMethod.getPSDEServiceAPIMethod()/>
</#if>
    <#if item.getPSAppDERSPathCount() gt 0 && singleServiceApi??>
    <#list 1..item.getPSAppDERSPathCount() as count>
        <#assign path = ''/>
        <#assign param = ''/>
        <#list item.getPSAppDERSPath(count_index)  as deRSPath>
            <#if deRSPath.getMajorPSAppDataEntity?? && deRSPath.getMajorPSAppDataEntity()??>
                <#assign _dataEntity = deRSPath.getMajorPSAppDataEntity()/>
                <#assign param>${param}'${_dataEntity.getKeyPSAppDEField().getCodeName()?lower_case}'<#if deRSPath_has_next>,</#if></#assign>
                <#assign path>${path}${srfpluralize(_dataEntity.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})\/</#assign>
            </#if>
        </#list>

        <#-- 方法类型为SELECT -->
        <#if singleAppMethod.getMethodType() == "SELECT">

// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    const paramArray:Array<any> = [${param},'${item.getKeyPSAppDEField().getCodeName()?lower_case}'];
    const matchArray:any = new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    let tempValue: any = {};
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
    let items = mockDatas ? mockDatas : [];
    let _items = items.find((item: any) => Object.is(item.${item.getKeyPSAppDEField().getCodeName()?lower_case}, tempValue.${item.getKeyPSAppDEField().getCodeName()?lower_case}));
<@endLog appMethod=singleAppMethod dataName="_items"/>
    return [status, _items];
});
        <#-- 方法类型为FETCH -->
        <#elseif singleAppMethod.getMethodType() == "FETCH">

// ${singleAppMethod.getCodeName()}
mock.onGet(new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    const paramArray:Array<any> = [${param}];
    let tempValue: any = {};
    const matchArray:any = new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
    let items = mockDatas ? mockDatas : [];
    if (items.length > 0 && paramArray.length > 0) {
        paramArray.forEach((paramkey: any) => {
            if (tempValue[paramkey] && tempValue[paramkey].indexOf(";") > 0) {
                let keysGrounp: Array<any> = tempValue[paramkey].split(new RegExp(/[\;]/));
                let tempArray: Array<any> = [];
                keysGrounp.forEach((singlekey: any) => {
                    let _items =  items.filter((item: any) => { return item[paramkey] == singlekey });
                   if(_items.length >0){
                    tempArray.push(..._items);
                   }
                })
                items = tempArray;
            } else {
                items = items.filter((item: any) => { return item[paramkey] == tempValue[paramkey] });
            }
        })
    }
<@endLog appMethod=singleAppMethod dataName="items"/>
    return [status, items];
});
        <#else>
        <#-- 方法类型为DEACTION start -->
            <#if singleServiceApi.getRequestParamType() == "NONE">
            <#-- 无参数情况start,如GetDraft -->

// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    // ${singleAppMethod.getCodeName()}
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
<@endLog appMethod=singleAppMethod dataName="{}"/>
    return [status, {}];
});
            <#-- 无参数情况end -->
            <#elseif singleServiceApi.getRequestParamType() == "FIELD">
            <#-- 指定属性情况start -->

// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }    
    const paramArray:Array<any> = [${param},'${item.getKeyPSAppDEField().getCodeName()?lower_case}'];
    const matchArray:any = new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    let tempValue: any = {};
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
    let items = mockDatas ? mockDatas : [];
    let _items = items.find((item: any) => Object.is(item.${item.getKeyPSAppDEField().getCodeName()?lower_case}, tempValue.${item.getKeyPSAppDEField().getCodeName()?lower_case}));
<@endLog appMethod=singleAppMethod dataName="_items?_items:{}"/>
    return [status, _items?_items:{}];
});
            <#-- 指定属性情况start -->
            <#elseif singleServiceApi.getRequestParamType() == "ENTITY">
            <#-- 提交对象数据情况start -->
    
// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    const paramArray:Array<any> = [${param},'${item.getKeyPSAppDEField().getCodeName()?lower_case}'];
    const matchArray:any = new RegExp(/^\/${path}${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    let tempValue: any = {};
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
<@endLog appMethod=singleAppMethod dataName="{}"/>
    return [status, {}];
});
            <#-- 提交对象数据情况start -->
            <#else>
            <#-- URI参数传递情况start -->
// URI参数传递情况未实现
            <#-- URI参数传递情况start -->
            </#if>
         <#-- 方法类型为DEACTION end -->
        </#if>
    </#list>
    </#if>
    <#if item.isMajor()>

        <#-- 方法类型为SELECT -->
        <#if singleAppMethod.getMethodType() == "SELECT">

// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }    
    const paramArray:Array<any> = ['${item.getKeyPSAppDEField().getCodeName()?lower_case}'];
    const matchArray:any = new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    let tempValue: any = {};
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
    let items = mockDatas ? mockDatas : [];
    let _items = items.find((item: any) => Object.is(item.${item.getKeyPSAppDEField().getCodeName()?lower_case}, tempValue.${item.getKeyPSAppDEField().getCodeName()?lower_case}));
<@endLog appMethod=singleAppMethod dataName="_items"/>
    return [status, _items];
});
        <#-- 方法类型为FETCH -->
        <#elseif singleAppMethod.getMethodType() == "FETCH">
    
// ${singleAppMethod.getCodeName()}
mock.onGet(new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
<@endLog appMethod=singleAppMethod dataName="mockDatas"/>
    return [status, mockDatas ? mockDatas : []];
});


// ${singleAppMethod.getCodeName()}
mock.onGet(new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>(\?[\w-./?%&=]*)*$/)).reply((config: any) => {
<@startLog singleAppMethod />
    if(config.url.includes('page')){
        let url = config.url.split('?')[1];
        let params  =  qs.parse(url);
        Object.assign(config, params);
    }
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    let total = mockDatas.length;
    let records: Array<any> = [];
    if(!config.page || !config.size){
        records = mockDatas;
    }else{
        if((config.page-1)*config.size < total){
          records = mockDatas.slice(config.page,config.size);
        }
    }
    <#--  if(config.query){
        records = records.filter(item => {
          return item.accountname.includes(config.query);
        })
    }  -->
<@endLog appMethod=singleAppMethod dataName="records ?  records : []"/>
    return [status, records ?  records : []];
});


        <#else>
        <#-- 方法类型为DEACTION start -->
            <#if singleServiceApi.getRequestParamType() == "NONE">
            <#-- 无参数情况start -->

// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    // ${singleAppMethod.getCodeName()}
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
<@endLog appMethod=singleAppMethod dataName="{}"/>
    return [status, {}];
});
            <#-- 无参数情况end -->
            <#elseif singleServiceApi.getRequestParamType() == "FIELD">
            <#-- 指定属性情况start -->
// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }    
    const paramArray:Array<any> = ['${item.getKeyPSAppDEField().getCodeName()?lower_case}'];
    const matchArray:any = new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    let tempValue: any = {};
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
    let items = mockDatas ? mockDatas : [];
    let _items = items.find((item: any) => Object.is(item.${item.getKeyPSAppDEField().getCodeName()?lower_case}, tempValue.${item.getKeyPSAppDEField().getCodeName()?lower_case}));
<@endLog appMethod=singleAppMethod dataName="_items?_items:{}"/>
    return [status, _items?_items:{}];
});
            <#-- 指定属性情况start -->
            <#elseif singleServiceApi.getRequestParamType() == "ENTITY">
            <#-- 提交对象数据情况start -->
        
// ${singleAppMethod.getCodeName()}
mock.on${srfclassname('${singleServiceApi.getRequestMethod()?lower_case}')}(new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}\/?([a-zA-Z0-9\-\;]{0,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/)).reply((config: any) => {
<@startLog singleAppMethod />
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }    
    const paramArray:Array<any> = ['${item.getKeyPSAppDEField().getCodeName()?lower_case}'];
    const matchArray:any = new RegExp(/^\/${srfpluralize(item.codeName)?lower_case}\/([a-zA-Z0-9\-\;]{1,35})<#if singleServiceApi.getRequestPath()??>\${singleServiceApi.getRequestPath()}</#if>$/).exec(config.url);
    let tempValue: any = {};
    if(matchArray && matchArray.length >1 && paramArray && paramArray.length >0){
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(tempValue, item, {
                enumerable: true,
                value: matchArray[index + 1]
            });
        });
    }
       <#if singleAppMethod.getCodeName() == "Create">
<@endLog appMethod=singleAppMethod dataName="mockDatas[0]"/>
    return [status, mockDatas[0]];
              <#else>
    //let items = mockDatas ? mockDatas : [];
    //let _items = items.find((item: any) => Object.is(item.${item.getKeyPSAppDEField().getCodeName()?lower_case}, tempValue.${item.getKeyPSAppDEField().getCodeName()?lower_case}));
      let data = JSON.parse(config.data);
    mockDatas.forEach((item)=>{
        if(item['${item.getKeyPSAppDEField().getCodeName()?lower_case}'] == tempValue['${item.getKeyPSAppDEField().getCodeName()?lower_case}'] ){
            for(let value in data){
              if(item.hasOwnProperty(value)){
                  item[value] = data[value];
              }
            }
        }
    })
<@endLog appMethod=singleAppMethod dataName="data"/>
    return [status, data];
              </#if>
});
            <#-- 提交对象数据情况start -->
            <#else>
            <#-- URI参数传递情况start -->
// URI参数传递情况未实现
            <#-- URI参数传递情况start -->
            </#if>
         <#-- 方法类型为DEACTION end -->
        </#if>
    </#if>
</#list>
</#if>
<#-- 实体接口mock数据end -->